Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.ejb
Interface EntityPersistenceManager

All Superinterfaces:
  AllowedOperationsFlags, ContainerPlugin, org.jboss.system.Service

All Known Implementing Classes:
  BMPPersistenceManager, CMPPersistenceManager

public interface EntityPersistenceManager
extends ContainerPlugin

This interface is implemented by any EntityBean persistence managers plugins.

Implementations of this interface are called by other plugins in the container. If the persistence manager wants to, it may attach any instance specific metadata to the EntityEnterpriseContext that is passed in method calls.

Version:
  $Revision: 1.21 $
Author:
  Rickard �berg, Dain Sundstrom
See Also:
  `EntityContainer`

Field Summary

Fields inherited from interface org.jboss.ejb.AllowedOperationsFlags
`IN_AFTER_BEGIN, IN_AFTER_COMPLETION, IN_BEFORE_COMPLETION, IN_BUSINESS_METHOD, IN_EJB_ACTIVATE, IN_EJB_CREATE, IN_EJB_FIND, IN_EJB_HOME, IN_EJB_LOAD, IN_EJB_PASSIVATE, IN_EJB_POST_CREATE, IN_EJB_REMOVE, IN_EJB_STORE, IN_EJB_TIMEOUT, IN_INTERCEPTOR_METHOD, IN_SERVICE_ENDPOINT_METHOD, IN_SET_ENTITY_CONTEXT, IN_SET_MESSAGE_DRIVEN_CONTEXT, IN_SET_SESSION_CONTEXT, IN_UNSET_ENTITY_CONTEXT, NOT_ALLOWED`

Method Summary
`void` | `activateEntity(EntityEnterpriseContext instance)` This method is called when an entity shall be activated.
`Object` | `createBeanClassInstance()` Returns a new instance of the bean class or a subclass of the bean class.
`void` | `createEntity(Method m, Object[] args, EntityEnterpriseContext instance)` This method is called whenever an entity is to be created.
`Collection` | `findEntities(Method finderMethod, Object[] args, EntityEnterpriseContext instance, GenericEntityObjectFactory factory)` This method is called when collections of entities are to be found.
`Object` | `findEntity(Method finderMethod, Object[] args, EntityEnterpriseContext instance, GenericEntityObjectFactory factory)` This method is called when single entities are to be found.
`void` | `invokeEjbStore(EntityEnterpriseContext instance)` Invokes ejbStore on the instance.
`boolean` | `isModified(EntityEnterpriseContext ctx)` This method is used to determined whether the instance was modified.
`boolean` | `isStoreRequired(EntityEnterpriseContext instance)` This method is used to determine if an entity should be stored.
`void` | `loadEntity(EntityEnterpriseContext instance)` This method is called whenever an entity shall be load from the underlying storage.
`void` | `passivateEntity(EntityEnterpriseContext instance)` This method is called when an entity shall be passivate.
`void` | `postCreateEntity(Method m, Object[] args, EntityEnterpriseContext instance)` This method is called whenever an entity is to be created.
`void` | `removeEntity(EntityEnterpriseContext instance)` This method is called when an entity shall be removed from the underlying storage.
`void` | `storeEntity(EntityEnterpriseContext instance)` This method is called whenever an entity shall be stored to the underlying storage.

Methods inherited from interface org.jboss.ejb.ContainerPlugin
`setContainer`

Methods inherited from interface org.jboss.system.Service
`create, destroy, start, stop`

Method Detail

### createBeanClassInstance

    public Object createBeanClassInstance()
                                   throws Exception

  Returns a new instance of the bean class or a subclass of the bean class.

  Returns:
    the new instance
  Throws:
    `Exception`

### createEntity

    public void createEntity(Method m,
                             Object[] args,
                             EntityEnterpriseContext instance)
                      throws Exception

  This method is called whenever an entity is to be created. The persistence manager is responsible for calling the ejbCreate method on the instance and to handle the results properly wrt the persistent store.

  Parameters:
    `m` - the create method in the home interface that was called
    `args` - any create parameters
    `instance` - the instance being used for this create call
  Throws:
    `Exception`

### postCreateEntity

    public void postCreateEntity(Method m,
                                 Object[] args,
                                 EntityEnterpriseContext instance)
                          throws Exception

  This method is called whenever an entity is to be created. The persistence manager is responsible for calling the ejbPostCreate method on the instance and to handle the results properly wrt the persistent store.

  Parameters:
    `m` - the create method in the home interface that was called
    `args` - any create parameters
    `instance` - the instance being used for this create call
  Throws:
    `Exception`

### findEntity

    public Object findEntity(Method finderMethod,
                             Object[] args,
                             EntityEnterpriseContext instance,
                             GenericEntityObjectFactory factory)
                      throws Exception

  This method is called when single entities are to be found. The persistence manager must find out whether the wanted instance is available in the persistence store, and if so it shall use the EJBProxyFactory plugin to create an EJBObject to the instance, which is to be returned as result.

  Parameters:
    `finderMethod` - the find method in the home interface that was called
    `args` - any finder parameters
    `instance` - the instance to use for the finder call
  Returns:
    an EJBObject representing the found entity
  Throws:
    `Exception`

### findEntities

    public Collection findEntities(Method finderMethod,
                                   Object[] args,
                                   EntityEnterpriseContext instance,
                                   GenericEntityObjectFactory factory)
                            throws Exception

  This method is called when collections of entities are to be found. The persistence manager must find out whether the wanted instances are available in the persistence store, and if so it shall use the EJBProxyFactory plugin to create EJBObjects to the instances, which are to be returned as result.

  Parameters:
    `finderMethod` - the find method in the home interface that was called
    `args` - any finder parameters
    `instance` - the instance to use for the finder call
  Returns:
    an EJBObject collection representing the found entities
  Throws:
    `Exception`

### activateEntity

    public void activateEntity(EntityEnterpriseContext instance)
                        throws RemoteException

  This method is called when an entity shall be activated. The persistence manager must call the ejbActivate method on the instance.

  Parameters:
    `instance` - the instance to use for the activation
  Throws:
    `RemoteException` - thrown if some system exception occurs

### loadEntity

    public void loadEntity(EntityEnterpriseContext instance)
                    throws RemoteException

  This method is called whenever an entity shall be load from the underlying storage. The persistence manager must load the state from the underlying storage and then call ejbLoad on the supplied instance.

  Parameters:
    `instance` - the instance to synchronize
  Throws:
    `RemoteException` - thrown if some system exception occurs

### isStoreRequired

    public boolean isStoreRequired(EntityEnterpriseContext instance)
                            throws Exception

  This method is used to determine if an entity should be stored.

  Parameters:
    `instance` - the instance to check
  Returns:
    true, if the entity has been modified
  Throws:
    `Exception` - thrown if some system exception occurs

### isModified

    public boolean isModified(EntityEnterpriseContext ctx)
                       throws Exception

  This method is used to determined whether the instance was modified. NOTE, even if the method returns true the isStoreRequired for this same instance might return false, e.g. a CMR field that doesn't have a foreign key was modified.

  Parameters:
    `ctx` -
  Returns:
  Throws:
    `Exception`

### storeEntity

    public void storeEntity(EntityEnterpriseContext instance)
                     throws RemoteException

  This method is called whenever an entity shall be stored to the underlying storage. The persistence manager must call ejbStore on the supplied instance and then store the state to the underlying storage.

  Parameters:
    `instance` - the instance to synchronize
  Throws:
    `RemoteException` - thrown if some system exception occurs

### invokeEjbStore

    public void invokeEjbStore(EntityEnterpriseContext instance)
                        throws RemoteException

  Invokes ejbStore on the instance.

  Parameters:
    `instance` -
  Throws:
    `RemoteException`

### passivateEntity

    public void passivateEntity(EntityEnterpriseContext instance)
                         throws RemoteException

  This method is called when an entity shall be passivate. The persistence manager must call the ejbPassivate method on the instance.

  Parameters:
    `instance` - the instance to passivate
  Throws:
    `RemoteException` - thrown if some system exception occurs

### removeEntity

    public void removeEntity(EntityEnterpriseContext instance)
                      throws RemoteException,
                             javax.ejb.RemoveException

  This method is called when an entity shall be removed from the underlying storage. The persistence manager must call ejbRemove on the instance and then remove its state from the underlying storage.

  Parameters:
    `instance` - the instance to remove
  Throws:
    `RemoteException` - thrown if some system exception occurs
    `javax.ejb.RemoveException` - thrown if the instance could not be removed

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 JBoss Group, LLC. All Rights Reserved.